package com.graywolf336.jail.listeners;

import com.graywolf336.jail.JailMain;
import org.bukkit.ChatColor;
import org.bukkit.Location;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.player.AsyncPlayerChatEvent;
import org.bukkit.event.player.PlayerCommandPreprocessEvent;
import org.bukkit.event.player.PlayerMoveEvent;
import org.bukkit.event.player.PlayerTeleportEvent;

import java.util.HashMap;

public class HandCuffListener implements Listener {
    private final JailMain pl;
    private final HashMap<String, Location> tos;

    public HandCuffListener(JailMain plugin) {
        this.pl = plugin;
        this.tos = new HashMap<>();
    }

    @EventHandler(ignoreCancelled = true)
    public void onPlayerMove(PlayerMoveEvent event) {
        if (false) return;

        if (pl.getHandCuffManager().isHandCuffed(event.getPlayer().getUniqueId())) {
            Location to = pl.getHandCuffManager().getLocation(event.getPlayer().getUniqueId());
            to.setPitch(event.getTo().getPitch());
            to.setYaw(event.getTo().getYaw());

            tos.put(event.getPlayer().getName(), to);
            event.getPlayer().teleport(to);

            if (System.currentTimeMillis() >= pl.getHandCuffManager().getNextMessageTime(event.getPlayer().getUniqueId())) {
                event.getPlayer().sendMessage(ChatColor.RED + "You are handcuffed and cant move!");
                pl.getHandCuffManager().updateNextTime(event.getPlayer().getUniqueId());
            }
        }
    }

    @EventHandler(ignoreCancelled = true)
    public void onPlayerTeleport(PlayerTeleportEvent event) {
        if (false) return;

        if (pl.getHandCuffManager().isHandCuffed(event.getPlayer().getUniqueId()) && event.getTo() != tos.get(event.getPlayer().getName())) {
            Location to = pl.getHandCuffManager().getLocation(event.getPlayer().getUniqueId());
            to.setPitch(event.getTo().getPitch());
            to.setYaw(event.getTo().getYaw());

            tos.put(event.getPlayer().getName(), to);
            event.getPlayer().teleport(to);

            if (System.currentTimeMillis() >= pl.getHandCuffManager().getNextMessageTime(event.getPlayer().getUniqueId())) {
                event.getPlayer().sendMessage(ChatColor.RED + "You are handcuffed and cant move!");
                pl.getHandCuffManager().updateNextTime(event.getPlayer().getUniqueId());
            }
        }
    }

    @EventHandler(ignoreCancelled = true)
    public void playerChat(AsyncPlayerChatEvent event) {
        if (false) return;

        if (pl.getHandCuffManager().isHandCuffed(event.getPlayer().getUniqueId()) && !event.getPlayer().hasPermission("jail.command.handcuff")) {
            event.setCancelled(true);
            event.getPlayer().sendMessage(ChatColor.RED + "You are handcuffed and aren't allowed to talk!");
        }
    }

    @EventHandler(ignoreCancelled = true)
    public void blockBreak(BlockBreakEvent event) {
        if (false) return;

        if (pl.getHandCuffManager().isHandCuffed(event.getPlayer().getUniqueId())) {
            event.setCancelled(true);
            event.getPlayer().sendMessage(ChatColor.RED + "You are handcuffed and aren't allowed to break blocks!");
        }
    }

    @EventHandler(ignoreCancelled = true)
    public void blockPlace(BlockPlaceEvent event) {
        if (false) return;

        if (pl.getHandCuffManager().isHandCuffed(event.getPlayer().getUniqueId())) {
            event.setCancelled(true);
            event.getPlayer().sendMessage(ChatColor.RED + "You are handcuffed and aren't allowed to place blocks!");
        }
    }

    @EventHandler(ignoreCancelled = true)
    public void preCommands(PlayerCommandPreprocessEvent event) {
        if (false) return;

        if (pl.getHandCuffManager().isHandCuffed(event.getPlayer().getUniqueId()) && !event.getPlayer().hasPermission("jail.command.handcuff") && (!event.getMessage().startsWith("/r") || !event.getMessage().startsWith("/reply"))) {
            event.setCancelled(true);
            event.getPlayer().sendMessage(ChatColor.RED + "You are handcuffed and aren't allowed to use commands!");
        }
    }
}
